import DataPack.*;

public class StringParser
{
	public DataPack convertString(String command)
	{
		String[] arg = command.split("[|]",2);
		DataPack dp = new DataPack();
		DataPack op = null;

		if (arg.length <2) return null;
		dp.setStringData(new String[]{arg[0]});

		if (arg[0].equals("queue"))
			op = makeQueueDataPack(arg[1]);
		else if (arg[0].equals("add"))
			op = makeAddDataPack(arg[1]);
		else if (arg[0].equals("wait"))
			op = makeWaitDataPack(arg[1]);
		else if (arg[0].equals("say"))
			op = makeSayDataPack(arg[1]);
		else if (arg[0].equals("move") || arg[0].equals("walk"))
			op = makeMoveDataPack(arg[1]);
		else if (arg[0].equals("turn"))
			op = makeTurnDataPack(arg[1]);
		else if (arg[0].equals("interrupt"))
			op = makeInterruptDataPack(arg[1]);
		else if (arg[0].equals("setPosition"))
			op = makeSetPositionDataPack(arg[1]);
		else if (arg[0].equals("setAngle"))
			op = makeSetAngleDataPack(arg[1]);
		else if (arg[0].equals("setCamTargetActor")
				 || arg[0].equals("setCamViewActor"))
			op = makeSetCamActor(arg[1]);
		else if (arg[0].equals("setCamTargetPoint")
				 || arg[0].equals("setCamViewPoint"))
			op = makeSetCamPoint(arg[1]);
		else if (arg[0].equals("setCamTargetLock")
				 || arg[0].equals("setCamViewLock"))
			op = makeSetCamLock(arg[1]);
		else if (arg[0].equals("open"))
			op = makeDoorOpen(arg[1]);
		
		if (op == null) return null;
		dp.setDataPack(new DataPack[]{op});
		return dp;
	}
	private DataPack makeQueueDataPack(String option)
	{
		DataPack dp = new DataPack();
		DataPack qdp;
		String[] arg = option.split("[|]",3);
		int q;
		if (arg.length<3) return null;
		if (arg[0].equals("")) return null;
		dp.setStringData(new String[]{arg[0]});
		try
		{
			q = Integer.valueOf(arg[1]).intValue();
		}catch(NumberFormatException e)
		{
			return null;
		}
		dp.setIntData(new int[]{q});
		qdp = convertString(arg[2]);
		if (qdp == null)
		{
			System.out.println("convert failed:"+arg[2]);
			return null;
		}
		dp.setDataPack(new DataPack[]{qdp});
		return dp;
	}
	private DataPack makeAddDataPack(String option)
	{
		DataPack dp = new DataPack();
		String[] arg = option.split("[|]");
		if (arg.length<2) return null;
		dp.setStringData(new String[]{arg[0],arg[1]});

		return dp;
	}
	private DataPack makeWaitDataPack(String option)
	{
		DataPack dp = new DataPack();
		String[] arg = option.split("[|]");
		int t;
		if (arg.length<1) return null;
		if (arg[0].equals("TIM"))  //ꤷ֤
		{
			if (arg.length<2) return null;
			try
			{
				t = Integer.valueOf(arg[1]).intValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{0,t});
		} else if(arg[0].equals("QUE")) //ꤷActorλꤷQueueߤޤޤԤ
		{
			if (arg.length<3) return null;
			dp.setStringData(new String[]{arg[1]});
			try
			{
				t=Integer.valueOf(arg[2]).intValue();;
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{1,t});
		} else if(arg[0].equals("ACT")) //ꤷActorActingޤԤ
		{
			if (arg.length<3) return null;
			dp.setIntData(new int[]{2});
			dp.setStringData(new String[]{arg[1],arg[2]});
		}else
		{
			return null;
		}
		return dp;
	}
	private DataPack makeSayDataPack(String option)
	{
		DataPack d = new DataPack();
		String[] arg = option.split("[|]");
		int t;
		int[] id = new int[3];

		if (arg.length < 3) return null;
		try{
			t = Integer.valueOf(arg[0]).intValue();
			id[0] = Integer.valueOf(arg[0]).intValue();
			id[1] = Integer.valueOf(arg[1]).intValue();
		}catch(NumberFormatException e)
		{
			return null;
		}

		if (arg[2].equals("GRP"))
		{
			if (arg.length < 6) return null;
			id[2] = 0;
			d.setStringData(new String[]{arg[3],arg[4],arg[5]});
		}else if (arg[2].equals("ACT"))
		{
			if (arg.length < 5) return null;
			id[2] = 1;
			d.setStringData(new String[]{arg[3],arg[4]});
		}else if (arg[2].equals("NOB"))
		{
			if (arg.length < 4) return null;
			id[2] = 2;
			d.setStringData(new String[]{arg[3]});
		}else
		{
			return null;
		}
		d.setIntData(id);
		return d;

	}
	private DataPack makeMoveDataPack(String option)
	{
		DataPack dp = new DataPack();
		double x,y,z,s,dist;
		int time;
		String[] tmp = option.split("[|]");
		if (tmp.length < 1)	return null; //ץ󤬤ʤʤ鼺
		if (tmp[0].equals("ACT")==true)  //ɸActor(ACT)ξ
		{
			if (tmp.length < 5)	return null;

			try
			{
				s = Double.valueOf(tmp[2]).doubleValue();
				dist = Double.valueOf(tmp[3]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}

			dp.setStringData(new String[]{tmp[1]});
			if (tmp[4].equals("0"))
				dp.setIntData(new int[]{0,0});
			else
				dp.setIntData(new int[]{0,1});
			dp.setDoubleData(new double[]{s,dist});
			
		}else if (tmp[0].equals("POS")){  //ɸξ
			if (tmp.length < 5)	return null;
			try
			{
				x=Double.valueOf(tmp[1]).doubleValue();
				y=Double.valueOf(tmp[2]).doubleValue();
				z=Double.valueOf(tmp[3]).doubleValue();
				s = Double.valueOf(tmp[4]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			
			dp.setIntData(new int[]{1});
			dp.setDoubleData(new double[]{x,y,z,s});
		}else if (tmp[0].equals("DIR")){   //ɸξ
			if (tmp.length < 6)	return null;
			try
			{
				x=Double.valueOf(tmp[1]).doubleValue();
				y=Double.valueOf(tmp[2]).doubleValue();
				z=Double.valueOf(tmp[3]).doubleValue();
				s = Double.valueOf(tmp[4]).doubleValue();
				time = Integer.valueOf(tmp[5]).intValue();  //ư
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{2,time});
			dp.setDoubleData(new double[]{x,y,z,s});
		}else{
			return null;
		}
		return dp;

	}
	private DataPack makeTurnDataPack(String option)
	{
		DataPack dp = new DataPack();
		double x,y,z,s;
		String[] tmp = option.split("[|]");
		if (tmp.length < 1)	return null;
		if (tmp[0].equals("ACT")==true)
		{
			if (tmp.length < 4)	return null;
			try
			{
				s = Double.valueOf(tmp[2]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}

			if (tmp[3].equals("0"))
				dp.setIntData(new int[]{0,0});
			else
				dp.setIntData(new int[]{0,1});
			dp.setStringData(new String[]{tmp[1]});
			dp.setDoubleData(new double[]{s});
		}else if (tmp[0].equals("POS")){
			if (tmp.length < 6)	return null;
			try
			{
				x=Double.valueOf(tmp[1]).doubleValue();
				y=Double.valueOf(tmp[2]).doubleValue();
				z=Double.valueOf(tmp[3]).doubleValue();
				s = Double.valueOf(tmp[4]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}

			if (tmp[5].equals("0"))
				dp.setIntData(new int[]{1,0});
			else
				dp.setIntData(new int[]{1,1});
			dp.setDoubleData(new double[]{x,y,z,s});
		}else if (tmp[0].equals("DIR")){
			if (tmp.length < 5)	return null;
			try
			{
				x=Double.valueOf(tmp[1]).doubleValue();
				y=Double.valueOf(tmp[2]).doubleValue();
				z=Double.valueOf(tmp[3]).doubleValue();
				s = Double.valueOf(tmp[4]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{2});
			dp.setDoubleData(new double[]{x,y,z,s});
		}else if (tmp[0].equals("ANG")){
			if (tmp.length < 4)	return null;
			try
			{
				x=Math.toRadians(Double.valueOf(tmp[1]).doubleValue());
				y=Math.toRadians(Double.valueOf(tmp[2]).doubleValue());
				s = Double.valueOf(tmp[3]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{3});
			dp.setDoubleData(new double[]{x,y,s});
		}else if (tmp[0].equals("LON")){
			if (tmp.length < 3)	return null;
			try
			{
				y = Math.toRadians(Double.valueOf(tmp[1]).doubleValue());
				s = Double.valueOf(tmp[2]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{4});
			dp.setDoubleData(new double[]{y,s});
		}else if (tmp[0].equals("LAT")){
			if (tmp.length < 3)	return null;
			try
			{
				x = Math.toRadians(Double.valueOf(tmp[1]).doubleValue());
				s = Double.valueOf(tmp[2]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setIntData(new int[]{5});
			dp.setDoubleData(new double[]{x,s});
		}else{
			return null;
		}
		
		return dp;
	}
	private DataPack makeInterruptDataPack(String option)
	{
		DataPack dp = new DataPack();
		String[] arg = option.split("[|]");
		int qnum,signal;
		if (arg.length<1) return null;
		if (arg[0].equals("ACT"))
		{
			if (arg.length<4) return null;
			try
			{
				signal = Integer.valueOf(arg[3]).intValue();
			}catch(NumberFormatException e)
			{
				return null;
			}

			dp.setStringData(new String[]{arg[1],arg[2]});
			dp.setIntData(new int[]{0,signal});
		} else if(arg[0].equals("QUE")) //ꤷActorλꤷQueueߤޤޤԤ
		{
			if (arg.length<4) return null;
			try
			{
				qnum=Integer.valueOf(arg[2]).intValue();;
				signal = Integer.valueOf(arg[3]).intValue();
			}catch(NumberFormatException e)
			{
				return null;
			}

			dp.setStringData(new String[]{arg[1]});
			dp.setIntData(new int[]{1,qnum,signal});
		} else {
			return null;
		}

		return dp;
	}

	private DataPack makeSetPositionDataPack(String option)
	{
		DataPack dp = new DataPack();
		double x,y,z;
		String[] tmp = option.split("[|]");
		if (tmp.length < 3)
		{
			return null;
		}
		try
		{
			x = Double.valueOf(tmp[0]).doubleValue();
			y = Double.valueOf(tmp[1]).doubleValue();
			z = Double.valueOf(tmp[2]).doubleValue();
		}catch(NumberFormatException e)
		{
			return null;
		}

		dp.setDoubleData(new double[]{x,y,z});
		return dp;
	}
	private DataPack makeSetAngleDataPack(String option)
	{
		DataPack dp = new DataPack();
		double x,y,z;
		String[] tmp = option.split("[|]");
		if (tmp.length < 1)	return null;			
		if (tmp[0].equals("ACT")==true)  //Actor⡼
		{
			if (tmp.length < 2)	return null;
			dp.setStringData(new String[]{tmp[1]});
			dp.setIntData(new int[]{0});
		}else if (tmp[0].equals("POS")){  //⡼
			if (tmp.length < 4)	return null;
			try
			{
				x=Double.valueOf(tmp[1]).doubleValue();
				y=Double.valueOf(tmp[2]).doubleValue();
				z=Double.valueOf(tmp[3]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setDoubleData(new double[]{x,y,z});
			dp.setIntData(new int[]{1});
		}else if (tmp[0].equals("DIR")){  //ꤵ줿٥ȥ⡼
			if (tmp.length < 4)	return null;
			try
			{
				x=Double.valueOf(tmp[1]).doubleValue();
				y=Double.valueOf(tmp[2]).doubleValue();
				z=Double.valueOf(tmp[3]).doubleValue();
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setDoubleData(new double[]{x,y,z});
			dp.setIntData(new int[]{2});
		}else if (tmp[0].equals("ANG")){  //ꤵ줿٤⡼
			if (tmp.length < 3)	return null;
			try
			{
				x=Math.toRadians(Double.valueOf(tmp[1]).doubleValue());
				y=Math.toRadians(Double.valueOf(tmp[2]).doubleValue());
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setDoubleData(new double[]{x,y});
			dp.setIntData(new int[]{3});
		}else if (tmp[0].equals("LON")){  //ꤵ줿٤⡼ɡlongitudeΤߡ
			if (tmp.length < 2)	return null;
			try
			{
				y=Math.toRadians(Double.valueOf(tmp[1]).doubleValue());
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setDoubleData(new double[]{y});
			dp.setIntData(new int[]{4});
		}else if (tmp[0].equals("LAT")){  //ꤵ줿٤⡼ɡlatitudeΤߡ
			if (tmp.length < 2)	return null;
			try
			{
				x=Math.toRadians(Double.valueOf(tmp[1]).doubleValue());
			}catch(NumberFormatException e)
			{
				return null;
			}
			dp.setDoubleData(new double[]{x});
			dp.setIntData(new int[]{5});
		}else{
			return null;
		}
		return dp;
	}

	private DataPack makeSetCamActor(String option)
	{
		DataPack dp = new DataPack();
		String[] tmp;
		tmp = option.split("[|]");
		if (tmp.length<1) return null;
		dp.setStringData(new String[]{tmp[0]});
		return dp;
	}
	private DataPack makeSetCamPoint(String option)
	{
		DataPack dp = new DataPack();
		double x,y,z;
		String[] tmp;
		tmp = option.split("[|]");
		if (tmp.length<3) return null;
		try
		{
			x=Double.valueOf(tmp[0]).doubleValue();
			y=Double.valueOf(tmp[1]).doubleValue();
			z=Double.valueOf(tmp[2]).doubleValue();
		}catch(NumberFormatException e)
		{
			return null;
		}
		dp.setDoubleData(new double[]{x,y,z});
		return dp;
	}
	private DataPack makeSetCamLock(String option)
	{
		DataPack dp = new DataPack();
		String[] tmp;
		tmp = option.split("[|]");
		if (tmp.length<1) return null;
		if (tmp[0].equals("0"))
			dp.setIntData(new int[]{0});
		else
			dp.setIntData(new int[]{1});
		return dp;
	}
	private DataPack makeDoorOpen(String option)
	{
		DataPack dp = new DataPack();
		double r,s;
		String[] tmp;
		tmp = option.split("[|]");
		if (tmp.length<2) return null;
		try
		{
			r=Math.toRadians(Double.valueOf(tmp[0]).doubleValue());
			s=Double.valueOf(tmp[1]).doubleValue();
		}catch(NumberFormatException e)
		{
			return null;
		}
		dp.setDoubleData(new double[]{r,s});
		return dp;
	}
}
